## fonts-inter 3.19+ds

=== Makefile ===
# To list all targets:
#   make list
#
# High-level make targets:
#   text              Build all Inter Text fonts (default target)
#   display           Build all Inter Display fonts
#   all               Build everything
#   web               Build all web fonts
#   var               Build all variable fonts
#   test              Run all test (builds fonts if needed)
#   zip               Build a complete ZIP archive of all fonts
#   zip_text          Build a complete ZIP archive of all Inter Text fonts
#   zip_display       Build a complete ZIP archive of all Inter Display fonts
#   install           Build and install all OTF files (macOS only)
#
# Style-specific targets:
#   STYLE_otf         Build OTF file for STYLE into FONTDIR/const
#   STYLE_ttf         Build TTF file for STYLE into FONTDIR/const
#   STYLE_ttf_hinted  Build TTF file for STYLE with hints into
#                     FONTDIR/const-hinted
#   STYLE_web         Build WOFF files for STYLE into FONTDIR/const
#   STYLE_web_hinted  Build WOFF files for STYLE with hints into
#                     FONTDIR/const-hinted
#   STYLE_check       Build & check OTF and TTF files for STYLE
#
# "build" directory output structure:
#   fonts
#     const
#     const-hinted
#     var
#
FONTDIR = build/fonts

default: text
all:     text display

# all fonts of given variant
text:    all_otf_text     all_ttf_text     all_ttf_text_hinted     all_var_text     web_text
display: all_otf_display  all_ttf_display  all_ttf_display_hinted  all_var_display  web_display

# all fonts of a certain type
all_otf:     all_otf_text  all_otf_display
all_ttf:     all_ttf_text  all_ttf_display  all_ttf_text_hinted  all_ttf_display_hinted

web:         web_text  web_display
web_text:    all_web_text     all_web_hinted_text
web_display: all_web_display  all_web_hinted_display

var: all_var_text  all_var_display
var_text:    $(FONTDIR)/var/Inter.var.woff2 $(FONTDIR)/var/Inter.var.ttf $(FONTDIR)/var/Inter-V.var.ttf
var_display: $(FONTDIR)/var/InterDisplay.var.woff2 $(FONTDIR)/var/InterDisplay.var.ttf $(FONTDIR)/var/InterDisplay-V.var.ttf
all_var_text: \
	$(FONTDIR)/var/Inter.var.ttf \
	$(FONTDIR)/var/Inter.var.woff2 \
	$(FONTDIR)/var/Inter-V.var.ttf \
	$(FONTDIR)/var/Inter-V.var.woff2 \
	$(FONTDIR)/var/Inter-roman.var.ttf \
	$(FONTDIR)/var/Inter-roman.var.woff2 \
	$(FONTDIR)/var/Inter-italic.var.ttf \
	$(FONTDIR)/var/Inter-italic.var.woff2
all_var_display: \
	$(FONTDIR)/var/InterDisplay.var.ttf \
	$(FONTDIR)/var/InterDisplay.var.woff2 \
	$(FONTDIR)/var/InterDisplay-V.var.ttf \
	$(FONTDIR)/var/InterDisplay-V.var.woff2 \
	$(FONTDIR)/var/InterDisplay-roman.var.ttf \
	$(FONTDIR)/var/InterDisplay-roman.var.woff2 \
	$(FONTDIR)/var/InterDisplay-italic.var.ttf \
	$(FONTDIR)/var/InterDisplay-italic.var.woff2

.PHONY: all  all_otf  all_ttf  text  display
.PHONY: web  web_text  web_display
.PHONY: var  var_text  var_display  all_var_text  all_var_display

# Hinted variable font disabled. See https://github.com/rsms/inter/issues/75
# all_var_hinted: $(FONTDIR)/var-hinted/Inter.var.ttf $(FONTDIR)/var-hinted/Inter.var.woff2

BIN := $(PWD)/build/venv/bin
export PATH := $(BIN):$(PATH)

# list make targets
# We copy the Makefile (first in MAKEFILE_LIST) and disable the include to only list
# primary targets, avoiding the generated targets.
.PHONY: list  list_all
list:
	@mkdir -p build/etc \
	&& cat $(firstword $(MAKEFILE_LIST)) \
	 | sed 's/include /#include /g' > build/etc/Makefile-list \
	&& $(MAKE) -pRrq -f build/etc/Makefile-list : 2>/dev/null \
	 | awk -v RS= -F: '/^# File/,/^# Finished Make data base/ {if ($$1 !~ "^[#.]") {print $$1}}' \
	 | sort \
	 | egrep -v -e '^[^[:alnum:]]' -e '^$@$$'
# list_all is like list, but includes generated targets
list_all:
	@$(MAKE) -pRrq -f $(firstword $(MAKEFILE_LIST)) : 2>/dev/null \
	 | awk -v RS= -F: '/^# File/,/^# Finished Make data base/ {if ($$1 !~ "^[#.]") {print $$1}}' \
	 | sort \
	 | egrep -v -e '^[^[:alnum:]]' -e '^$@$$'

# generated.make is automatically generated by init.sh and defines depenencies for
# all styles and alias targets
include build/etc/generated.make


# WOFF2 from TTF
build/%.woff2: build/%.ttf
	$(BIN)/woff2_compress "$<"

# WOFF from TTF
build/%.woff: build/%.ttf
	$(BIN)/ttf2woff -O -t woff "$<" "$@"



# VF OTF from UFO
$(FONTDIR)/var/Inter.var.ttf: $(all_ufo_masters_text) version.txt
	@mkdir -p "$(dir $@)"
	misc/fontbuild compile-var -o $@ $(FONTBUILD_FLAGS) build/ufo/Inter.designspace
	$(BIN)/gftools fix-unwanted-tables -t MVAR $@
	$(BIN)/gftools fix-dsig --autofix $@

$(FONTDIR)/var/Inter-V.var.ttf: $(FONTDIR)/var/Inter.var.ttf
	misc/fontbuild rename --family "Inter V" -o $@ $<

$(FONTDIR)/var/Inter-%.var.ttf: build/ufo/Inter-%.designspace $(all_ufo_masters_text) version.txt
	@mkdir -p "$(dir $@)"
	misc/fontbuild compile-var -o $@ $(FONTBUILD_FLAGS) $<
	misc/tools/fix-vf-meta.py $@
	$(BIN)/gftools fix-unwanted-tables -t MVAR $@
	$(BIN)/gftools fix-dsig --autofix $@


$(FONTDIR)/var/InterDisplay.var.ttf: $(all_ufo_masters_display) version.txt
	@mkdir -p "$(dir $@)"
	misc/fontbuild compile-var -o $@ $(FONTBUILD_FLAGS) build/ufo/InterDisplay.designspace
	$(BIN)/gftools fix-unwanted-tables -t MVAR $@
	$(BIN)/gftools fix-dsig --autofix $@

$(FONTDIR)/var/InterDisplay-V.var.ttf: $(FONTDIR)/var/InterDisplay.var.ttf
	misc/fontbuild rename --family "Inter Display V" -o $@ $<

$(FONTDIR)/var/InterDisplay-%.var.ttf: build/ufo/InterDisplay-%.designspace $(all_ufo_masters_display) version.txt
	@mkdir -p "$(dir $@)"
	misc/fontbuild compile-var -o $@ $(FONTBUILD_FLAGS) $<
	misc/tools/fix-vf-meta.py $@
	$(BIN)/gftools fix-unwanted-tables -t MVAR $@
	$(BIN)/gftools fix-dsig --autofix $@


# OTF/TTF from UFO
$(FONTDIR)/const/Inter%.otf: build/ufo/Inter%.ufo version.txt
	@mkdir -p "$(dir $@)"
	misc/fontbuild compile -o $@ $(FONTBUILD_FLAGS) build/ufo/Inter$*.ufo

$(FONTDIR)/const/Inter%.ttf: build/ufo/Inter%.ufo version.txt
	@mkdir -p "$(dir $@)"
	misc/fontbuild compile -o $@ $(FONTBUILD_FLAGS) build/ufo/Inter$*.ufo


# DESIGNSPACE from GLYPHS
build/ufo/Inter-roman.designspace: build/ufo/Inter.designspace
build/ufo/Inter-italic.designspace: build/ufo/Inter.designspace
build/ufo/Inter.designspace: src/Inter.glyphs
	@mkdir -p build/ufo
	misc/fontbuild glyphsync -o build/ufo src/Inter.glyphs
build/ufo/InterDisplay-roman.designspace: build/ufo/InterDisplay.designspace
build/ufo/InterDisplay-italic.designspace: build/ufo/InterDisplay.designspace
build/ufo/InterDisplay.designspace: src/InterDisplay.glyphs
	@mkdir -p build/ufo
	misc/fontbuild glyphsync -o build/ufo src/InterDisplay.glyphs


# short-circuit Make for performance
src/Inter.glyphs:
	@true
src/InterDisplay.glyphs:
	@true

# make sure intermediate files are not gc'd by make
.PRECIOUS: build/ufo/Inter-*.designspace build/ufo/InterDisplay-*.designspace

designspace: build/ufo/Inter.designspace build/ufo/InterDisplay.designspace
.PHONY: designspace


# features
src/features: $(wildcard src/features/*)
	@touch "$@"
	@true
build/ufo/features: src/features
	@mkdir -p build/ufo
	@rm -f build/ufo/features
	@ln -s ../../src/features build/ufo/features

# make sure intermediate UFOs are not gc'd by make
.PRECIOUS: build/ufo/Inter-%.ufo

# Note: The seemingly convoluted dependency graph above is required to
# make sure that glyphsync and instancegen are not run in parallel.


# hinted TTF files via autohint
$(FONTDIR)/const-hinted/%.ttf: $(FONTDIR)/const/%.ttf
	mkdir -p "$(dir $@)"
	$(BIN)/ttfautohint --windows-compatibility --adjust-subglyphs --no-info "$<" "$@"

# python -m ttfautohint --fallback-stem-width=256 --no-info "$<" "$@"

# $(FONTDIR)/var-hinted/%.ttf: $(FONTDIR)/var/%.ttf
# 	mkdir -p "$(dir $@)"
# 	ttfautohint --fallback-stem-width=256 --no-info "$<" "$@"

# make sure intermediate TTFs are not gc'd by make
.PRECIOUS: $(FONTDIR)/const/%.ttf
.PRECIOUS: $(FONTDIR)/const/%.otf
.PRECIOUS: $(FONTDIR)/const-hinted/%.ttf
.PRECIOUS: $(FONTDIR)/var/%.var.ttf



# test runs all tests
# Note: all_check_const is generated by init.sh and runs "fontbuild checkfont"
# on all otf and ttf files.
test: test_text  test_display

test_text: check_text \
           build/fbreport-text-const.txt \
           build/fbreport-text-var1.txt \
           build/fbreport-text-var2.txt
  @echo "$(@): OK"

test_display: check_display \
              build/fbreport-display-const.txt \
              build/fbreport-display-var1.txt \
              build/fbreport-display-var2.txt
  @echo "$(@): OK"

# FBAKE_ARGS are common args for all fontbakery targets
FBAKE_ARGS := check-universal \
              --no-colors \
              --no-progress \
              --loglevel WARN \
              --succinct \
              -j \
              -x com.google.fonts/check/dsig \
              -x com.google.fonts/check/unitsperem \
              -x com.google.fonts/check/family/win_ascent_and_descent \
              -x com.google.fonts/check/fontbakery_version

FBAKE_STATIC_ARGS := $(FBAKE_ARGS) -x com.google.fonts/check/family/underline_thickness
FBAKE_VAR_ARGS    := $(FBAKE_ARGS) -x com.google.fonts/check/STAT_strings

# static text family
build/fbreport-text-const.txt: $(wildcard $(FONTDIR)/const/Inter-*.otf)
	@echo "fontbakery check-universal Inter-*.otf > $(@) ..."
	@$(BIN)/fontbakery $(FBAKE_STATIC_ARGS) $^ > $@ || \
	  (cat $@; echo "report at $@"; touch -m -t 199001010000 $@; exit 1)
	@echo "fontbakery check-universal Inter-*.otf OK"

# multi-axis VF text family
build/fbreport-text-var2.txt: $(FONTDIR)/var/Inter.var.ttf
	@echo "fontbakery check-universal Inter.var.ttf > $(@) ..."
	@$(BIN)/fontbakery $(FBAKE_VAR_ARGS) $^ > $@ || \
	  (cat $@; echo "report at $@"; touch -m -t 199001010000 $@; exit 1)
	@echo "fontbakery check-universal Inter.var.ttf"

# single-axis VF text family
build/fbreport-text-var1.txt: $(wildcard $(FONTDIR)/var/Inter-*.var.ttf)
	@echo "fontbakery check-universal Inter-*.var.ttf > $(@) ..."
	@$(BIN)/fontbakery $(FBAKE_VAR_ARGS) $^ > $@ || \
	  (cat $@; echo "report at $@"; touch -m -t 199001010000 $@; exit 1)
	@echo "fontbakery check-universal Inter-*.var.ttf"


# static display family
build/fbreport-display-const.txt: $(wildcard $(FONTDIR)/const/InterDisplay-*.otf)
	@echo "fontbakery check-universal InterDisplay-*.otf > $(@) ..."
	@$(BIN)/fontbakery $(FBAKE_STATIC_ARGS) $^ > $@ || \
	  (cat $@; echo "report at $@"; touch -m -t 199001010000 $@; exit 1)
	@echo "fontbakery check-universal InterDisplay-*.otf"

# multi-axis VF display family
build/fbreport-display-var2.txt: $(FONTDIR)/var/InterDisplay.var.ttf
	@echo "fontbakery check-universal InterDisplay.var.ttf > $(@) ..."
	@$(BIN)/fontbakery $(FBAKE_VAR_ARGS) $^ > $@ || \
	  (cat $@; echo "report at $@"; touch -m -t 199001010000 $@; exit 1)
	@echo "fontbakery check-universal InterDisplay.var.ttf"

# single-axis VF display family
build/fbreport-display-var1.txt: $(wildcard $(FONTDIR)/var/InterDisplay-*.var.ttf)
	@echo "fontbakery check-universal InterDisplay-*.var.ttf > $(@) ..."
	@$(BIN)/fontbakery $(FBAKE_VAR_ARGS) $^ > $@ || \
	  (cat $@; echo "report at $@"; touch -m -t 199001010000 $@; exit 1)
	@echo "fontbakery check-universal InterInterDisplay-*.var.ttf"

# check does the same thing as test, but without any dependency checks, meaning
# it will check whatever font files are already built.
check_text: $(wildcard $(FONTDIR)/const/Inter-*.ttf) \
            $(wildcard $(FONTDIR)/const/Inter-*.otf) \
            $(wildcard $(FONTDIR)/const/Inter-*.woff2) \
            $(wildcard $(FONTDIR)/var/Inter-*.var.ttf) \
            $(wildcard $(FONTDIR)/var/Inter-*.var.woff2) \
            $(FONTDIR)/var/Inter.var.ttf \
            $(FONTDIR)/var/Inter.var.woff2
	misc/fontbuild checkfont $^
	@echo "$(@): OK"

check_display: $(wildcard $(FONTDIR)/const/InterDisplay-*.ttf) \
               $(wildcard $(FONTDIR)/const/InterDisplay-*.otf) \
               $(wildcard $(FONTDIR)/const/InterDisplay-*.woff2) \
               $(wildcard $(FONTDIR)/var/InterDisplay-*.var.ttf) \

=== requirements.txt ===
fonttools[lxml,unicode,ufo]==4.21.1
cu2qu==1.6.7
glyphsLib==5.3.2
ufo2ft[pathops]==2.20.0
defcon[lxml]==0.8.1
skia-pathops==0.6.0.post2
gftools==0.7.0

# only used for DesignSpaceDocumentReader in fontbuild
MutatorMath==3.0.1

# for woff2
brotli==1.0.9

# for QA
fontbakery==0.7.37

=== misc/ttf2woff/Makefile ===
# gmake

NAME = ttf2woff
VERSION = 0.14
BINDIR = /usr/local/bin
PKG=$(NAME)-$(VERSION)
FILES_TTF2WOFF := Makefile ttf2woff.c ttf2woff.h genwoff.c genttf.c readttf.c  readttc.c readwoff.c optimize.c \
  comp-zlib.c comp-zopfli.c compat.c ttf2woff.rc zopfli.diff
FILES_ZOPFLI := zopfli.h symbols.h \
  $(patsubst %,%.h,zlib_container deflate lz77 blocksplitter squeeze hash cache tree util katajainen) \
  $(patsubst %,%.c,zlib_container deflate lz77 blocksplitter squeeze hash cache tree util katajainen)
FILES += $(FILES_TTF2WOFF) $(addprefix zopfli/,$(FILES_ZOPFLI))

ZOPFLI = 1

OBJ := ttf2woff.o readttf.o readttc.o readwoff.o genwoff.o genttf.o optimize.o
ifeq ($(ZOPFLI),)
OBJ += comp-zlib.o
else
OBJ += comp-zopfli.o
LDFLAGS += -lm
endif

CFLAGS ?= -O2 -g
LDFLAGS += -lz

# eg. make WIN32=1 CC=mingw32-gcc RC=mingw32-windres
ifdef WIN32
EXE = .exe
CFLAGS += -DNO_ERRWARN
OBJ += compat.o rc.o
endif

ttf2woff$(EXE): $(OBJ)
	$(CC) -o $@ $(OBJ) $(LDFLAGS)

ttf2woff.o: ttf2woff.c ttf2woff.h Makefile
	$(CC) $(CFLAGS) -DVERSION=$(VERSION) -c ttf2woff.c

comp-zopfli.o: comp-zopfli.c ttf2woff.h $(addprefix zopfli/,$(FILES_ZOPFLI))
	$(CC) $(CFLAGS) -c comp-zopfli.c

rc.o: ttf2woff.rc Makefile
	$(RC) $(DEF) -DVERNUMS=`echo $(VERSION) | sed 's/\\./,/g; s/[^0-9,]//g'` -DVERSION=$(VERSION) -o $@ ttf2woff.rc

install: ttf2woff
	install -s $< $(BINDIR)

clean:
	rm -f ttf2woff $(addsuffix .o,$(basename $(filter %.c,$(FILES_TTF2WOFF))))

dist:
	ln -s . $(PKG)
	tar czf $(PKG).tar.gz --group=root --owner=root $(addprefix $(PKG)/, $(FILES)); \
	rm $(PKG)

.PHONY: install clean dist zopfli zopfli.diff


# git://github.com/google/zopfli.git
ZOPFLI_SRC = zopfli-src
zopfli: $(addprefix $(ZOPFLI_SRC)/src/zopfli/,$(FILES_ZOPFLI))
	@install -d zopfli
	cp -pf $^ zopfli
	patch -p3 -dzopfli <zopfli.diff

zopfli.diff:
	diff -u --minimal $(ZOPFLI_SRC)/src/zopfli zopfli >$@; true

=== misc/tools/fontsample/Makefile ===
sources = fontsample.mm

CC = clang
CXX = clang
LD = clang

XFLAGS    := -Wall -g -fno-common
CFLAGS    += -std=c11
CXXFLAGS  += -std=c++11 -stdlib=libc++ -fno-rtti -fno-exceptions
LDFLAGS   += -lc++

#flags release and debug targets (e.g. make DEBUG=1)
ifeq ($(strip $(DEBUG)),1)
	XFLAGS += -O0
# else
# 	XFLAGS += -Os -DNDEBUG
endif

libs := -lobjc
frameworks := -framework Foundation \
              -framework CoreText \
              -framework CoreServices \
              -framework CoreGraphics \
              -framework ImageIO

c_flags   = $(CFLAGS) $(XFLAGS) -MMD -fobjc-arc
cxx_flags = $(CXXFLAGS) $(XFLAGS) -MMD -fobjc-arc
ld_flags  = $(LDFLAGS) $(libs) $(frameworks)

objects := $(sources:%.c=%.o)
objects := $(objects:%.cc=%.o)
objects := $(objects:%.mm=%.o)

fontsample: $(objects)
	$(LD) $(ld_flags) -o $@ $^

%.o: %.mm
	$(CXX) $(cxx_flags) -c $<

clean:
	rm -f *.o

all: fontsample
.PHONY: all clean

=== debian/changelog ===
fonts-inter (3.19+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 15 Aug 2021 11:46:16 +0200

fonts-inter (3.19+ds-1) experimental; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 20 Jun 2021 21:50:33 +0200

fonts-inter (3.18+ds-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.5.1.
  * d/watch: added filemangle for repacking.
  * Drop unused lintian override.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 01 Apr 2021 08:23:23 +0200

fonts-inter (3.15+ds-3) unstable; urgency=medium

  * d/rules: Patch adding --expand-features-to-instances for fontmake.
    Thanks Bart Martens. (Closes: #978365)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 23 Feb 2021 06:41:28 +0100

=== debian/control ===
Source: fonts-inter
Section: fonts
Priority: optional
Maintainer: Debian Fonts Task Force <pkg-fonts-devel@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper-compat (= 13), fontmake, ufo2otf, python3-fontforge, fontforge-nox | fontforge
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/fonts-team/fonts-inter.git
Vcs-Browser: https://salsa.debian.org/fonts-team/fonts-inter
Homepage: https://rsms.me/inter/

Package: fonts-inter
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Inter font family
 This is a typeface specially designed for user interfaces with focus
 on high legibility of small-to-medium sized text on computer screens.
 .
 The family features a tall x-height to aid in readability of
 mixed-case and lower-case text. Several OpenType features are
 provided as well, like contextual alternates that adjusts punctuation
 depending on the shape of surrounding glyphs, slashed zero for when
 you need to disambiguate "0" from "o", tabular numbers, etc.

Package: fonts-inter-variable
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Inter font family (VF)
 This is a typeface specially designed for user interfaces with focus
 on high legibility of small-to-medium sized text on computer screens.
 .
 The family features a tall x-height to aid in readability of
 mixed-case and lower-case text. Several OpenType features are
 provided as well, like contextual alternates that adjusts punctuation
 depending on the shape of surrounding glyphs, slashed zero for when
 you need to disambiguate "0" from "o", tabular numbers, etc.
 .
 This is the VF variant of the font.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_configure:
	mkdir -p instance_ufo/features
	mkdir -p master_ufo/features
	cp src/features/*.fea instance_ufo/features
	cp src/features/*.fea master_ufo/features

override_dh_auto_build:
	fontmake --expand-features-to-instances -i -o otf -g src/Inter.glyphs
	fontmake --expand-features-to-instances -o variable -g src/Inter.glyphs

override_dh_auto_test:
	@echo skipping test

override_dh_auto_clean:
	rm -rf instance_ufo/* master_ufo/*
	@echo skipping clean

override_dh_auto_install:
	@echo skipping install

## fonts-inter 4.0~beta7+ds

=== Makefile ===
# List all targets with 'make list'
SRCDIR   := $(abspath $(lastword $(MAKEFILE_LIST))/..)
FONTDIR  := build/fonts
UFODIR   := build/ufo
BIN      := $(SRCDIR)/build/venv/bin
VENV     := build/venv/bin/activate
VERSION  := $(shell cat version.txt)
MAKEFILE := $(lastword $(MAKEFILE_LIST))

export PATH := $(BIN):$(PATH)

default: all

# ---------------------------------------------------------------------------------
# intermediate sources

$(UFODIR)/%.glyphs: src/%.glyphspackage | $(UFODIR) venv
	. $(VENV) ; build/venv/bin/glyphspkg -o $(dir $@) $^

# features
src/features: $(wildcard src/features/*)
	@touch "$@"
	@true
$(UFODIR)/features: src/features
	@mkdir -p $(UFODIR)
	@rm -f $(UFODIR)/features
	@ln -s ../../src/features $(UFODIR)/features

# designspace
$(UFODIR)/%.designspace: $(UFODIR)/%.glyphs $(UFODIR)/features | venv
	. $(VENV) ; fontmake -o ufo -g $< --designspace-path $@ \
		--master-dir $(UFODIR) --instance-dir $(UFODIR)
	. $(VENV) ; python misc/tools/postprocess-designspace.py $@

# UFOs from designspace
$(UFODIR)/Inter-%Italic.ufo: $(UFODIR)/Inter-Italic.designspace | venv
	. $(VENV) ; bash misc/tools/gen-instance-ufo.sh $< $@
$(UFODIR)/Inter-%.ufo: $(UFODIR)/Inter-Roman.designspace | venv
	. $(VENV) ; bash misc/tools/gen-instance-ufo.sh $< $@

# make sure intermediate files are not rm'd by make
.PRECIOUS: \
	$(UFODIR)/Inter-Black.ufo \
	$(UFODIR)/Inter-Regular.ufo \
	$(UFODIR)/Inter-Thin.ufo \
	$(UFODIR)/Inter-Light.ufo \
	$(UFODIR)/Inter-ExtraLight.ufo \
	$(UFODIR)/Inter-Medium.ufo \
	$(UFODIR)/Inter-SemiBold.ufo \
	$(UFODIR)/Inter-Bold.ufo \
	$(UFODIR)/Inter-ExtraBold.ufo \
	\
	$(UFODIR)/Inter-BlackItalic.ufo \
	$(UFODIR)/Inter-Italic.ufo \
	$(UFODIR)/Inter-ThinItalic.ufo \
	$(UFODIR)/Inter-LightItalic.ufo \
	$(UFODIR)/Inter-ExtraLightItalic.ufo \
	$(UFODIR)/Inter-MediumItalic.ufo \
	$(UFODIR)/Inter-SemiBoldItalic.ufo \
	$(UFODIR)/Inter-BoldItalic.ufo \
	$(UFODIR)/Inter-ExtraBoldItalic.ufo \
	\
	$(UFODIR)/Inter-DisplayBlack.ufo \
	$(UFODIR)/Inter-Display.ufo \
	$(UFODIR)/Inter-DisplayThin.ufo \
	$(UFODIR)/Inter-DisplayLight.ufo \
	$(UFODIR)/Inter-DisplayExtraLight.ufo \
	$(UFODIR)/Inter-DisplayMedium.ufo \
	$(UFODIR)/Inter-DisplaySemiBold.ufo \
	$(UFODIR)/Inter-DisplayBold.ufo \
	$(UFODIR)/Inter-DisplayExtraBold.ufo \
	\
	$(UFODIR)/Inter-DisplayBlackItalic.ufo \
	$(UFODIR)/Inter-DisplayItalic.ufo \
	$(UFODIR)/Inter-DisplayThinItalic.ufo \
	$(UFODIR)/Inter-DisplayLightItalic.ufo \
	$(UFODIR)/Inter-DisplayExtraLightItalic.ufo \
	$(UFODIR)/Inter-DisplayMediumItalic.ufo \
	$(UFODIR)/Inter-DisplaySemiBoldItalic.ufo \
	$(UFODIR)/Inter-DisplayBoldItalic.ufo \
	$(UFODIR)/Inter-DisplayExtraBoldItalic.ufo \
	\
	$(UFODIR)/Inter-Roman.glyphs \
	$(UFODIR)/Inter-Italic.glyphs \
	$(UFODIR)/Inter-Roman.designspace \
	$(UFODIR)/Inter-Italic.designspace

# ---------------------------------------------------------------------------------
# products

$(FONTDIR)/static/%.otf: $(UFODIR)/%.ufo | $(FONTDIR)/static venv
	. $(VENV) ; fontmake -u $< -o otf --output-path $@ --overlaps-backend pathops --production-names

$(FONTDIR)/static/%.ttf: $(UFODIR)/%.ufo | $(FONTDIR)/static venv
	. $(VENV) ; fontmake -u $< -o ttf --output-path $@ --overlaps-backend pathops --production-names

$(FONTDIR)/static-hinted/%.ttf: $(FONTDIR)/static/%.ttf | $(FONTDIR)/static-hinted venv
	. $(VENV) ; python -m ttfautohint --no-info "$<" "$@"

$(FONTDIR)/var/_%.var.ttf: $(UFODIR)/%.designspace | $(FONTDIR)/var venv
	. $(VENV) ; fontmake -o variable -m $< --output-path $@ \
	              --overlaps-backend pathops --production-names

$(FONTDIR)/var/_%.var.otf: $(UFODIR)/%.designspace | $(FONTDIR)/var venv
	. $(VENV) ; fontmake -o variable-cff2 -m $< --output-path $@ \
	              --overlaps-backend pathops --production-names

%.woff2: %.ttf | venv
	. $(VENV) ; misc/tools/woff2 compress -o "$@" "$<"

$(FONTDIR)/static:
	mkdir -p $@
$(FONTDIR)/static-hinted:
	mkdir -p $@
$(FONTDIR)/var:
	mkdir -p $@
$(UFODIR):
	mkdir -p $@

# roman + italic with STAT
$(FONTDIR)/var/inter-roman-and-italic.stamp: \
	  $(FONTDIR)/var/_Inter-Roman.var.ttf \
	  $(FONTDIR)/var/_Inter-Italic.var.ttf \
	  | venv
	@#. $(VENV) ; python misc/tools/postprocess-vf2.py $^
	mkdir $(FONTDIR)/var/gen-stat
	. $(VENV) ; gftools gen-stat --out $(FONTDIR)/var/gen-stat $^
	mv $(FONTDIR)/var/gen-stat/_Inter-Roman.var.ttf $(FONTDIR)/var/Inter.var.ttf
	mv $(FONTDIR)/var/gen-stat/_Inter-Italic.var.ttf $(FONTDIR)/var/Inter-Italic.var.ttf
	rm -rf $(FONTDIR)/var/gen-stat
	touch $@

$(FONTDIR)/var/Inter.var.ttf: $(FONTDIR)/var/inter-roman-and-italic.stamp
	touch $@
$(FONTDIR)/var/Inter-Italic.var.ttf: $(FONTDIR)/var/inter-roman-and-italic.stamp
	touch $@

$(FONTDIR)/var/InterV.var.ttf: $(FONTDIR)/var/Inter.var.ttf | venv
	. $(VENV) ; python misc/tools/rename.py --family "Inter V" -o $@ $<
$(FONTDIR)/var/InterV-Italic.var.ttf: $(FONTDIR)/var/Inter-Italic.var.ttf | venv
	. $(VENV) ; python misc/tools/rename.py --family "Inter V" -o $@ $<

var: \
	$(FONTDIR)/var/Inter.var.ttf \
	$(FONTDIR)/var/Inter-Italic.var.ttf \
	$(FONTDIR)/var/InterV.var.ttf \
	$(FONTDIR)/var/InterV-Italic.var.ttf

var_web: \
	$(FONTDIR)/var/Inter.var.woff2 \
	$(FONTDIR)/var/Inter-Italic.var.woff2

web: var_web static_web

static_otf: \
	$(FONTDIR)/static/Inter-Black.otf \
	$(FONTDIR)/static/Inter-BlackItalic.otf \
	$(FONTDIR)/static/Inter-Regular.otf \
	$(FONTDIR)/static/Inter-Italic.otf \
	$(FONTDIR)/static/Inter-Thin.otf \
	$(FONTDIR)/static/Inter-ThinItalic.otf \
	$(FONTDIR)/static/Inter-Light.otf \
	$(FONTDIR)/static/Inter-LightItalic.otf \
	$(FONTDIR)/static/Inter-ExtraLight.otf \
	$(FONTDIR)/static/Inter-ExtraLightItalic.otf \
	$(FONTDIR)/static/Inter-Medium.otf \
	$(FONTDIR)/static/Inter-MediumItalic.otf \
	$(FONTDIR)/static/Inter-SemiBold.otf \
	$(FONTDIR)/static/Inter-SemiBoldItalic.otf \
	$(FONTDIR)/static/Inter-Bold.otf \
	$(FONTDIR)/static/Inter-BoldItalic.otf \
	$(FONTDIR)/static/Inter-ExtraBold.otf \
	$(FONTDIR)/static/Inter-ExtraBoldItalic.otf \
	$(FONTDIR)/static/Inter-DisplayBlack.otf \
	$(FONTDIR)/static/Inter-DisplayBlackItalic.otf \
	$(FONTDIR)/static/Inter-Display.otf \
	$(FONTDIR)/static/Inter-DisplayItalic.otf \
	$(FONTDIR)/static/Inter-DisplayThin.otf \
	$(FONTDIR)/static/Inter-DisplayThinItalic.otf \
	$(FONTDIR)/static/Inter-DisplayLight.otf \
	$(FONTDIR)/static/Inter-DisplayLightItalic.otf \
	$(FONTDIR)/static/Inter-DisplayExtraLight.otf \
	$(FONTDIR)/static/Inter-DisplayExtraLightItalic.otf \
	$(FONTDIR)/static/Inter-DisplayMedium.otf \
	$(FONTDIR)/static/Inter-DisplayMediumItalic.otf \
	$(FONTDIR)/static/Inter-DisplaySemiBold.otf \
	$(FONTDIR)/static/Inter-DisplaySemiBoldItalic.otf \
	$(FONTDIR)/static/Inter-DisplayBold.otf \
	$(FONTDIR)/static/Inter-DisplayBoldItalic.otf \
	$(FONTDIR)/static/Inter-DisplayExtraBold.otf \
	$(FONTDIR)/static/Inter-DisplayExtraBoldItalic.otf

static_ttf: \
	$(FONTDIR)/static/Inter-Black.ttf \
	$(FONTDIR)/static/Inter-BlackItalic.ttf \
	$(FONTDIR)/static/Inter-Regular.ttf \
	$(FONTDIR)/static/Inter-Italic.ttf \
	$(FONTDIR)/static/Inter-Thin.ttf \
	$(FONTDIR)/static/Inter-ThinItalic.ttf \
	$(FONTDIR)/static/Inter-Light.ttf \
	$(FONTDIR)/static/Inter-LightItalic.ttf \
	$(FONTDIR)/static/Inter-ExtraLight.ttf \
	$(FONTDIR)/static/Inter-ExtraLightItalic.ttf \
	$(FONTDIR)/static/Inter-Medium.ttf \
	$(FONTDIR)/static/Inter-MediumItalic.ttf \
	$(FONTDIR)/static/Inter-SemiBold.ttf \
	$(FONTDIR)/static/Inter-SemiBoldItalic.ttf \
	$(FONTDIR)/static/Inter-Bold.ttf \
	$(FONTDIR)/static/Inter-BoldItalic.ttf \
	$(FONTDIR)/static/Inter-ExtraBold.ttf \
	$(FONTDIR)/static/Inter-ExtraBoldItalic.ttf \
	$(FONTDIR)/static/Inter-DisplayBlack.ttf \
	$(FONTDIR)/static/Inter-DisplayBlackItalic.ttf \
	$(FONTDIR)/static/Inter-Display.ttf \
	$(FONTDIR)/static/Inter-DisplayItalic.ttf \
	$(FONTDIR)/static/Inter-DisplayThin.ttf \
	$(FONTDIR)/static/Inter-DisplayThinItalic.ttf \
	$(FONTDIR)/static/Inter-DisplayLight.ttf \
	$(FONTDIR)/static/Inter-DisplayLightItalic.ttf \
	$(FONTDIR)/static/Inter-DisplayExtraLight.ttf \
	$(FONTDIR)/static/Inter-DisplayExtraLightItalic.ttf \
	$(FONTDIR)/static/Inter-DisplayMedium.ttf \
	$(FONTDIR)/static/Inter-DisplayMediumItalic.ttf \
	$(FONTDIR)/static/Inter-DisplaySemiBold.ttf \
	$(FONTDIR)/static/Inter-DisplaySemiBoldItalic.ttf \
	$(FONTDIR)/static/Inter-DisplayBold.ttf \
	$(FONTDIR)/static/Inter-DisplayBoldItalic.ttf \
	$(FONTDIR)/static/Inter-DisplayExtraBold.ttf \
	$(FONTDIR)/static/Inter-DisplayExtraBoldItalic.ttf

static_ttf_hinted: \
	$(FONTDIR)/static-hinted/Inter-Black.ttf \
	$(FONTDIR)/static-hinted/Inter-BlackItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-Regular.ttf \
	$(FONTDIR)/static-hinted/Inter-Italic.ttf \
	$(FONTDIR)/static-hinted/Inter-Thin.ttf \
	$(FONTDIR)/static-hinted/Inter-ThinItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-Light.ttf \
	$(FONTDIR)/static-hinted/Inter-LightItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-ExtraLight.ttf \
	$(FONTDIR)/static-hinted/Inter-ExtraLightItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-Medium.ttf \
	$(FONTDIR)/static-hinted/Inter-MediumItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-SemiBold.ttf \
	$(FONTDIR)/static-hinted/Inter-SemiBoldItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-Bold.ttf \
	$(FONTDIR)/static-hinted/Inter-BoldItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-ExtraBold.ttf \
	$(FONTDIR)/static-hinted/Inter-ExtraBoldItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayBlack.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayBlackItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-Display.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayThin.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayThinItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayLight.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayLightItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayExtraLight.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayExtraLightItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayMedium.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayMediumItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplaySemiBold.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplaySemiBoldItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayBold.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayBoldItalic.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayExtraBold.ttf \
	$(FONTDIR)/static-hinted/Inter-DisplayExtraBoldItalic.ttf

static_web: \
	$(FONTDIR)/static/Inter-Black.woff2 \
	$(FONTDIR)/static/Inter-BlackItalic.woff2 \
	$(FONTDIR)/static/Inter-Regular.woff2 \
	$(FONTDIR)/static/Inter-Italic.woff2 \
	$(FONTDIR)/static/Inter-Thin.woff2 \
	$(FONTDIR)/static/Inter-ThinItalic.woff2 \
	$(FONTDIR)/static/Inter-Light.woff2 \
	$(FONTDIR)/static/Inter-LightItalic.woff2 \
	$(FONTDIR)/static/Inter-ExtraLight.woff2 \
	$(FONTDIR)/static/Inter-ExtraLightItalic.woff2 \
	$(FONTDIR)/static/Inter-Medium.woff2 \
	$(FONTDIR)/static/Inter-MediumItalic.woff2 \
	$(FONTDIR)/static/Inter-SemiBold.woff2 \
	$(FONTDIR)/static/Inter-SemiBoldItalic.woff2 \
	$(FONTDIR)/static/Inter-Bold.woff2 \
	$(FONTDIR)/static/Inter-BoldItalic.woff2 \
	$(FONTDIR)/static/Inter-ExtraBold.woff2 \
	$(FONTDIR)/static/Inter-ExtraBoldItalic.woff2 \
	$(FONTDIR)/static/Inter-DisplayBlack.woff2 \
	$(FONTDIR)/static/Inter-DisplayBlackItalic.woff2 \
	$(FONTDIR)/static/Inter-Display.woff2 \
	$(FONTDIR)/static/Inter-DisplayItalic.woff2 \
	$(FONTDIR)/static/Inter-DisplayThin.woff2 \
	$(FONTDIR)/static/Inter-DisplayThinItalic.woff2 \
	$(FONTDIR)/static/Inter-DisplayLight.woff2 \
	$(FONTDIR)/static/Inter-DisplayLightItalic.woff2 \
	$(FONTDIR)/static/Inter-DisplayExtraLight.woff2 \
	$(FONTDIR)/static/Inter-DisplayExtraLightItalic.woff2 \
	$(FONTDIR)/static/Inter-DisplayMedium.woff2 \
	$(FONTDIR)/static/Inter-DisplayMediumItalic.woff2 \
	$(FONTDIR)/static/Inter-DisplaySemiBold.woff2 \
	$(FONTDIR)/static/Inter-DisplaySemiBoldItalic.woff2 \
	$(FONTDIR)/static/Inter-DisplayBold.woff2 \
	$(FONTDIR)/static/Inter-DisplayBoldItalic.woff2 \
	$(FONTDIR)/static/Inter-DisplayExtraBold.woff2 \
	$(FONTDIR)/static/Inter-DisplayExtraBoldItalic.woff2

=== requirements.txt ===
fontmake==3.4.*
fontbakery==0.8.*
skia-pathops==0.7.*
gftools==0.9.*
glyphspkg==0.1.*
brotli==1.0.*

=== docs/Makefile ===
SRCDIR  := $(abspath $(lastword $(MAKEFILE_LIST))/../..)
BIN     := $(SRCDIR)/build/venv/bin
FONTDIR := ../build/fonts
export PATH := $(BIN):$(PATH)

default:
	@echo "Please specify a target: build, serve or dist" >&2

build: .ruby-bundle
	rm -rf _site
	bundle exec jekyll build

serve: .ruby-bundle
	./_scripts/serve.sh

.ruby-bundle: Gemfile Gemfile.lock
	@if ! (command -v bundle >/dev/null && command -v jekyll >/dev/null); then \
	  echo "Please install Ruby bundle and jekyll: gem install bundler jekyll" >&2; \
	  exit 1; \
	fi
	bundle update
	bundle install
	touch .ruby-bundle

# -----------------------------------------------------------------------

dist: fonts info
	$(BIN)/python3 ../misc/tools/patch-version.py lab/index.html

info: _data/fontinfo.json \
      lab/glyphinfo.json \
      glyphs/metrics.json

fonts:
	rm -rf font-files/Inter-* font-files/Inter.var*
	mkdir -p font-files
	cp -a $(FONTDIR)/static/Inter-*.woff2 \
	      $(FONTDIR)/static/Inter-*.otf \
	      $(FONTDIR)/var/Inter.var.* \
	      $(FONTDIR)/var/Inter-roman.var.* \
	      $(FONTDIR)/var/Inter-italic.var.* \
	      font-files/

_data/fontinfo.json: ../misc/tools/fontinfo.py font-files/Inter-Regular.otf
	$(BIN)/python3 ../misc/tools/fontinfo.py -pretty $< > _data/fontinfo.json

lab/glyphinfo.json: ../misc/tools/gen-glyphinfo.py \
                    ../build/ufo/Inter-Regular.ufo \
                    ../misc/UnicodeData.txt
	$(BIN)/python3 ../misc/tools/gen-glyphinfo.py \
		-ucd ../misc/UnicodeData.txt ../build/ufo/Inter-Regular.ufo > $@

glyphs/metrics.json: ../misc/tools/gen-metrics-and-svgs.py \
                     ../build/ufo/Inter-Regular.ufo
	$(BIN)/python3 ../misc/tools/gen-metrics-and-svgs.py ../build/ufo/Inter-Regular.ufo
	@# Note: this also patches glyphs/index.html

font-files/Inter-Regular.otf: fonts

.PHONY: default build serve dist info fonts

=== debian/changelog ===
fonts-inter (4.0~beta7+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Wed, 26 Oct 2022 16:33:51 +0200

fonts-inter (4.0~beta6+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Tue, 18 Oct 2022 10:24:26 +0200

fonts-inter (4.0~beta5+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 10 Oct 2022 07:10:34 +0200

fonts-inter (4.0~beta1+ds-2) unstable; urgency=medium

  * Upload to sid.

 -- Gürkan Myczko <tar@debian.org>  Sun, 02 Oct 2022 19:59:05 +0200

fonts-inter (4.0~beta1+ds-1) experimental; urgency=medium

  * New upstream version. (Closes: #1017286)
  * Switch to upstream prebuilt fonts due to unavailable
    building tools of upstream.
  * Bump standards version to 4.6.1.
  * Update maintainer email.
  * d/copyright: bump years.
  * d/*.install: updated paths.
  * d/rules: skip building.

 -- Gürkan Myczko <tar@debian.org>  Fri, 30 Sep 2022 15:02:43 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: fonts
 Priority: optional
 Maintainer: Debian Fonts Task Force <pkg-fonts-devel@lists.alioth.debian.org>
-Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
-Build-Depends: debhelper-compat (= 13), fontmake, ufo2otf, python3-fontforge, fontforge-nox | fontforge
-Standards-Version: 4.5.1
+Uploaders: Gürkan Myczko <tar@debian.org>
+Build-Depends: debhelper-compat (= 13),
+# commented out for the future, when we switch to build from source again
+# fontmake, ufo2otf, python3-fontforge, fontforge-nox | fontforge
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/fonts-team/fonts-inter.git
 Vcs-Browser: https://salsa.debian.org/fonts-team/fonts-inter

=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds$//,repacksuffix=+ds,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/$1\.tar\.gz/ \
 https://github.com/rsms/inter/tags .*/v?(\d\S*)\.tar\.gz
